//+------------------------------------------------------------------+
//|                                                          HLV.mq4 |
//|                                                           brax64 |
//+------------------------------------------------------------------+
//
// Original idea by Egor at codebase.mql4.com
//
#property copyright "brax64"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Silver
#property indicator_color2 Crimson
#property indicator_color3 DodgerBlue
#property indicator_color4 DimGray
#property indicator_color5 DimGray
#property indicator_width1 2
#property indicator_width2 4
#property indicator_width3 4
#property indicator_width4 0
#property indicator_width5 0

extern int    HL_Period      = 20;
extern bool   Show_Bands     = true;
extern string note           = "Band_smoothing <= 1 for no smoothing";
extern int    Band_smoothing = 4;

int    limit, counted_bars, k, i;
double str[], HLplus[], HLminus[], HIb[], LOb[], wrk0[], wrk1[];
double a, b, c, d, e;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
   IndicatorDigits(6);
   IndicatorBuffers(8);
   IndicatorShortName("HLV ("+HL_Period+")");
   
   SetIndexStyle(0, DRAW_HISTOGRAM); SetIndexBuffer(0, str);     SetIndexLabel(0, "Strength ");
   SetIndexStyle(1, DRAW_HISTOGRAM); SetIndexBuffer(1, HLminus); SetIndexLabel(1, "HL- ");
   SetIndexStyle(2, DRAW_HISTOGRAM); SetIndexBuffer(2, HLplus);  SetIndexLabel(2, "HL+ "); 
     if (Show_Bands)
      {
       SetIndexStyle(3, DRAW_LINE);  SetIndexBuffer(3, HIb);     SetIndexLabel(3, "H_Band ");
       SetIndexStyle(4, DRAW_LINE);  SetIndexBuffer(4, LOb);     SetIndexLabel(4, "L_Band ");
       SetIndexStyle(5, DRAW_NONE);  SetIndexBuffer(5, wrk0);
       SetIndexStyle(6, DRAW_NONE);  SetIndexBuffer(6, wrk1);
      }
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
   {
    counted_bars = IndicatorCounted();
    if(counted_bars > 0) counted_bars--;
    limit = Bars - counted_bars;      
     
    for(k = 0; k < limit; k++)
      { 
       a = 0;
       b = 0;
       c = 0;
       d = 0;
       e = 0;
       for(i = 0 + k; i < HL_Period + k; i++) 
         {    
          if(iHigh(NULL, 0, k) > iHigh(NULL, 0, i) && iHigh(NULL, 0, k) - iHigh(NULL, 0, i ) > a)
          a = iHigh(NULL, 0, k) - iHigh(NULL, 0, i);
         
          if(iLow(NULL, 0, k) < iLow(NULL, 0, i) && iLow(NULL, 0, k) - iLow(NULL, 0, i) < b)
          b = iLow(NULL, 0, k) - iLow(NULL, 0, i);
          
          c = a + b;
          d = a - b;
          e = b - a;          
         }
       
       str[k]     = EMPTY_VALUE;
       HLminus[k] = EMPTY_VALUE;
       HLplus[k]  = EMPTY_VALUE;
       wrk0[k]    = EMPTY_VALUE;
       
       if(c == d || c == e)     str[k] = -c * 0.75;
       if(c < 0)            HLminus[k] =  c;
       if(c > 0)             HLplus[k] =  c;
       if(c == 0)         
                          { 
                            HLminus[k] =  0;
                             HLplus[k] =  0;
                          }
                               wrk0[k] =  d * 1.618;
      }
      
    for(k = 0; k < limit; k++)
      {                        
       wrk1[k] = NormalizeDouble(iMAOnArray(wrk0,0,Band_smoothing,0,1,k),4);
       if (Show_Bands)
         {
          if(Band_smoothing > 1)
            {
             IndicatorShortName("HLV smoothed bands ("+HL_Period+", "+Band_smoothing+")");
             HIb[k] = wrk1[k];
             LOb[k] = -HIb[k];
            }
          else
            {
             IndicatorShortName("HLV bands ("+HL_Period+")");
             HIb[k] = wrk0[k];
             LOb[k] = -HIb[k];
            }
         }            
      }
    return(0);
   }

